Index: trunk/MESOSCALE/LMD_MM_MARS/SRC/WRFV2/Registry/Registry.EM
===================================================================
--- trunk/MESOSCALE/LMD_MM_MARS/SRC/WRFV2/Registry/Registry.EM	(revision 2016)
+++ trunk/MESOSCALE/LMD_MM_MARS/SRC/WRFV2/Registry/Registry.EM	(revision 2018)
@@ -117,4 +117,20 @@
 state  real  DT_VDF     ikj   misc  1  -  -  "DT_VDF"     "PBL CLMAIN TEMPERATURE TENDENCY"                 "K/s"
 state  real  DT_AJS     ikj   misc  1  -  -  "DT_AJS"     "AJUSTEMENT SEC TEMPERATURE TENDENCY"                 "K/s"
+state  real  CLOUDFRAC  ikj  misc  1  -  -  "CLOUDFRAC"     "CLOUD FRACTION"           ""
+state  real  TOTCLOUDFRAC  ij  misc  1  -  -  "TOTCLOUDFRAC"     "COLUMN CLOUD FRACTION"           ""
+state  real  GRAIN  ikj  misc  1  -  -  "RAIN"     "RAIN kg/kg.s-1"           ""
+state  real  GSNOW  ikj  misc  1  -  -  "SNOW"     "SNOW kg/kg.s-1"           ""
+state  real  ALBEQ  ij misc  1  -  -  "ALBEQ"    "ALBEDO EQUIVALENT"   ""
+state  real  FLUXTOP_DN ij misc  1  -  - "FLUXTOP_DN"   "Incoming SW radiation at the TOA" "W.m-2"
+state  real  FLUXABS_SW ij misc  1  -  - "FLUXABS_SW"  "Absorbed SW flux" "W.m-2"
+state  real  FLUXTOP_LW ij misc  1  -  - "FLUXTOP_LW"  "Outgoing LW flux TOA" "W.m-2"
+state  real  FLUXSURF_SW ij misc  1  -  - "FLUXSURF_SW" "SW Surface flux" "W.m-2"
+state  real  FLUXSURF_LW ij misc  1  -  -  "FLUXSURF_LW" "LW Surface flux" "W.m-2"
+state  real  FLXGRD ij misc  1  -  - "FLXGRD" "heat flux from ground"  "W.m-2"
+state  real  LSCEZ ikj misc  1  -  - "LSCEZ" "heat from largescale" "W.m-2"
+state  real  H2OICE_REFF ikj misc  1  -  -  "H2OICE_REFF" "Radii of H2O ice" "m"
+state  real  LATENT_HF ij misc  1  -  -  "LATENT_HF" "latent heat flux" "W.m-2"
+state  real  REEVAP    ij misc  1  -  -  "REEVAP" "re-evaporation flux of precipitation (integrated over the atmospheric column)"
+state  real  SURFRAIN  ij misc  1  -  -  "SURFRAIN" "Rainfall" "kg m-2 s-1"
 
 ####
Index: trunk/MESOSCALE/LMD_MM_MARS/SRC/WRFV2/Registry/Registry.EM.newphys
===================================================================
--- trunk/MESOSCALE/LMD_MM_MARS/SRC/WRFV2/Registry/Registry.EM.newphys	(revision 2016)
+++ trunk/MESOSCALE/LMD_MM_MARS/SRC/WRFV2/Registry/Registry.EM.newphys	(revision 2018)
@@ -99,4 +99,22 @@
 state  real  ZMAX       ij   misc  1  -  h  "ZMAX"      "MAXIMUM LEVEL THERMALS"          "m"    
 state  real  HFMAX      ij   misc  1  -  h  "HFMAX"     "MAXIMUM PBL HEAT FLUX"           "m.K/s"
+#### GENERIC OUTPUTS
+state  real  CLOUDFRAC  ikj  misc  1  -  -  "CLOUDFRAC"     "CLOUD FRACTION"           ""
+state  real  TOTCLOUDFRAC  ij  misc  1  -  -  "TOTCLOUDFRAC"     "COLUMN CLOUD FRACTION"           ""
+state  real  GRAIN  ikj  misc  1  -  -  "RAIN"     "RAIN kg/kg.s-1"           ""
+state  real  GSNOW  ikj  misc  1  -  -  "SNOW"     "SNOW kg/kg.s-1"           ""
+state  real  ALBEQ  ij misc  1  -  -  "ALBEQ"    "ALBEDO EQUIVALENT"   ""
+state  real  FLUXTOP_DN ij misc  1  -  - "FLUXTOP_DN"   "Incoming SW radiation at the TOA" "W.m-2"
+state  real  FLUXABS_SW ij misc  1  -  - "FLUXABS_SW"  "Absorbed SW flux" "W.m-2"
+state  real  FLUXTOP_LW ij misc  1  -  - "FLUXTOP_LW"  "Outgoing LW flux TOA" "W.m-2"
+state  real  FLUXSURF_SW ij misc  1  -  - "FLUXSURF_SW" "SW Surface flux" "W.m-2"
+state  real  FLUXSURF_LW ij misc  1  -  -  "FLUXSURF_LW" "LW Surface flux" "W.m-2"
+state  real  FLXGRD ij misc  1  -  - "FLXGRD" "heat flux from ground"  "W.m-2"
+state  real  LSCEZ ikj misc  1  -  - "LSCEZ" "heat from largescale" "W.m-2"
+state  real  H2OICE_REFF ikj misc  1  -  -  "H2OICE_REFF" "Radii of H2O ice" "m"
+state  real  LATENT_HF ij misc  1  -  -  "LATENT_HF" "Latent heat flux" "W.m-2"
+state  real  REEVAP    ij misc  1  -  -  "REEVAP" "Re-evaporation flux of precipitation (integrated over the atmospheric column)"
+state  real  SURFRAIN  ij misc  1  -  -  "SURFRAIN" "Rainfall" "kg m-2 s-1"
+
 ####
 ####
Index: trunk/MESOSCALE/LMD_MM_MARS/SRC/WRFV2/dyn_em/solve_em.F
===================================================================
--- trunk/MESOSCALE/LMD_MM_MARS/SRC/WRFV2/dyn_em/solve_em.F	(revision 2016)
+++ trunk/MESOSCALE/LMD_MM_MARS/SRC/WRFV2/dyn_em/solve_em.F	(revision 2018)
@@ -897,4 +897,20 @@
      &       ,DT_VDF=grid%DT_VDF  &
      &       ,DT_AJS=grid%DT_AJS  &
+     &       ,CLOUDFRAC=grid%CLOUDFRAC   &
+     &       ,TOTCLOUDFRAC=grid%TOTCLOUDFRAC   &
+     &       ,GRAIN=grid%GRAIN   &
+     &       ,GSNOW=grid%GSNOW   &
+     &       ,REEVAP=grid%REEVAP  &
+     &       ,SURFRAIN=grid%SURFRAIN  &
+     &       ,ALBEQ=grid%ALBEQ   &
+     &       ,FLUXTOP_DN=grid%FLUXTOP_DN   &
+     &       ,FLUXABS_SW=grid%FLUXABS_SW   &
+     &       ,FLUXTOP_LW=grid%FLUXTOP_LW   &
+     &       ,FLUXSURF_SW=grid%FLUXSURF_SW   &
+     &       ,FLUXSURF_LW=grid%FLUXSURF_LW   &
+     &       ,FLXGRD=grid%FLXGRD   &
+     &       ,LSCEZ=grid%LSCEZ   &
+     &       ,H2OICE_REFF=grid%H2OICE_REFF  &
+     &       ,LATENT_HF=grid%LATENT_HF  &
      &       ,SWDOWNZ=grid%SWDOWNZ   &
      &       ,TAU_DUST=grid%TAU_DUST   &
Index: trunk/MESOSCALE/LMD_MM_MARS/SRC/WRFV2/phys/dynphy_wrf_generic_lmd_new/update_outputs_physiq_mod.F
===================================================================
--- trunk/MESOSCALE/LMD_MM_MARS/SRC/WRFV2/phys/dynphy_wrf_generic_lmd_new/update_outputs_physiq_mod.F	(revision 2016)
+++ trunk/MESOSCALE/LMD_MM_MARS/SRC/WRFV2/phys/dynphy_wrf_generic_lmd_new/update_outputs_physiq_mod.F	(revision 2018)
@@ -158,6 +158,10 @@
             SWDOWNZ,TAU_DUST,QSURFDUST,&
             MTOT,ICETOT,TAU_ICE,&
-            HR_SW,HR_LW,HR_DYN,DT,DTRAD,DTVDF,DTAJS,&
-            RDUST,VMR_ICE,RICE)
+            HR_SW,HR_LW,HR_DYN,DT,DTRAD,&
+            RDUST,VMR_ICE,RICE,&
+            CLOUDFRAC,TOTCLOUDFRAC,&
+            RAIN,SNOW,REEVAP,SURFRAIN,ALBEQ,FLUXTOP_DN,FLUXABS_SW,FLUXTOP_LW,FLUXSURF_SW,&
+            FLUXSURF_LW,FLXGRD,LSCEZ,H2OICE_REFF,LATENT_HF)
+
    USE comm_wrf !! to get fields to be written from physiq
 
@@ -167,6 +171,9 @@
      SWDOWNZ,TAU_DUST,QSURFDUST,&
      MTOT,ICETOT,TAU_ICE,&
+     TOTCLOUDFRAC,ALBEQ,FLUXTOP_DN,FLUXABS_SW,FLUXTOP_LW,FLUXSURF_SW,&
+     FLUXSURF_LW,FLXGRD,LATENT_HF,REEVAP,SURFRAIN
    REAL, DIMENSION( ims:ime, kms:kme, jms:jme ), INTENT(INOUT ) :: &
-     HR_SW,HR_LW,RDUST,VMR_ICE,RICE,HR_DYN,DT,DTRAD,DTVDF,DTAJS
+     HR_SW,HR_LW,RDUST,VMR_ICE,RICE,CLOUDFRAC,HR_DYN,DT,DTRAD,RAIN,SNOW,&
+     LSCEZ,H2OICE_REFF
    INTEGER :: i,j,subs
 
@@ -180,13 +187,22 @@
 
      !! get diagnostics from physics
-     SWDOWNZ(i,j) = comm_SWDOWNZ(subs)
-     MTOT(i,j) = comm_MTOT(subs)
      HR_SW(i,kps:kpe,j) = comm_HR_SW(subs,kps:kpe)
      HR_LW(i,kps:kpe,j) = comm_HR_LW(subs,kps:kpe)
-     HR_DYN(i,kps:kpe,j) = comm_HR_DYN(subs,kps:kpe)
-     DT(i,kps:kpe,j) = comm_DT(subs,kps:kpe)
-     DTRAD(i,kps:kpe,j) = comm_DT_RAD(subs,kps:kpe)
-     DTVDF(i,kps:kpe,j) = comm_DT_VDF(subs,kps:kpe)
-     DTAJS(i,kps:kpe,j) = comm_DT_AJS(subs,kps:kpe)
+     CLOUDFRAC(i,kps:kpe,j)= comm_CLOUDFRAC(subs,kps:kpe)
+     TOTCLOUDFRAC(i,j)= comm_TOTCLOUDFRAC(subs)
+     RAIN(i,kps:kpe,j) = comm_RAIN(subs,kps:kpe)
+     SNOW(i,kps:kpe,j) = comm_SNOW(subs,kps:kpe)
+     ALBEQ(i,j)=comm_ALBEQ(subs)
+     FLUXTOP_DN(i,j)=comm_FLUXTOP_DN(subs)
+     FLUXABS_SW(i,j)=comm_FLUXABS_SW(subs)
+     FLUXTOP_LW(i,j)=comm_FLUXTOP_LW(subs)
+     FLUXSURF_SW(i,j)=comm_FLUXSURF_SW(subs)
+     FLUXSURF_LW(i,j)=comm_FLUXSURF_LW(subs)
+     FLXGRD(i,j)=comm_FLXGRD(subs)
+     LSCEZ(i,kps:kpe,j)=comm_LSCEZ(subs,kps:kpe)
+     H2OICE_REFF(i,kps:kpe,j)=comm_H2OICE_REFF(subs,kps:kpe)
+     LATENT_HF(i,j)=comm_LATENT_HF(subs)
+     REEVAP(i,j)=comm_REEVAP(subs)
+     SURFRAIN(i,j)=comm_SURFRAIN(subs)
 
    ENDDO
Index: trunk/MESOSCALE/LMD_MM_MARS/SRC/WRFV2/phys/dynphy_wrf_mars_lmd_new/update_outputs_physiq_mod.F
===================================================================
--- trunk/MESOSCALE/LMD_MM_MARS/SRC/WRFV2/phys/dynphy_wrf_mars_lmd_new/update_outputs_physiq_mod.F	(revision 2016)
+++ trunk/MESOSCALE/LMD_MM_MARS/SRC/WRFV2/phys/dynphy_wrf_mars_lmd_new/update_outputs_physiq_mod.F	(revision 2018)
@@ -167,7 +167,10 @@
             SWDOWNZ,TAU_DUST,QSURFDUST,&
             MTOT,ICETOT,TAU_ICE,&
-            HR_SW,HR_LW,HR_DYN,DT,DTRAD,DTVDF,DTAJS,&
-            RDUST,VMR_ICE,RICE)
-
+            HR_SW,HR_LW,HR_DYN,DT,DTRAD,&
+            RDUST,VMR_ICE,RICE,&
+            CLOUDFRAC,TOTCLOUDFRAC,&
+            RAIN,SNOW,REEVAP,SURFRAIN,ALBEQ,FLUXTOP_DN,FLUXABS_SW,FLUXTOP_LW,FLUXSURF_SW,&
+            FLUXSURF_LW,FLXGRD,LSCEZ,H2OICE_REFF,LATENT_HF)
+   
    USE comm_wrf !! to get fields to be written from physiq
 
@@ -176,8 +179,12 @@
    REAL, DIMENSION( ims:ime, jms:jme ), INTENT(INOUT) :: &
      SWDOWNZ,TAU_DUST,QSURFDUST,&
-     MTOT,ICETOT,TAU_ICE
+     MTOT,ICETOT,TAU_ICE,&
+     TOTCLOUDFRAC,ALBEQ,FLUXTOP_DN,FLUXABS_SW,FLUXTOP_LW,FLUXSURF_SW,&
+     FLUXSURF_LW,FLXGRD,LATENT_HF,REEVAP,SURFRAIN
    REAL, DIMENSION( ims:ime, kms:kme, jms:jme ), INTENT(INOUT ) :: &
-     HR_SW,HR_LW,HR_DYN,RDUST,VMR_ICE,RICE,DT,DTRAD,DTVDF,DTAJS
-   INTEGER :: i,j,subs
+     HR_SW,HR_LW,RDUST,VMR_ICE,RICE,CLOUDFRAC,HR_DYN,DT,DTRAD,RAIN,SNOW,&
+     LSCEZ,H2OICE_REFF
+   INTEGER :: i,j,subs
+
 
    DO j = jps,jpe
Index: trunk/MESOSCALE/LMD_MM_MARS/SRC/WRFV2/phys/dynphy_wrf_prescribed_void_lmd_new/update_outputs_physiq_mod.F
===================================================================
--- trunk/MESOSCALE/LMD_MM_MARS/SRC/WRFV2/phys/dynphy_wrf_prescribed_void_lmd_new/update_outputs_physiq_mod.F	(revision 2016)
+++ trunk/MESOSCALE/LMD_MM_MARS/SRC/WRFV2/phys/dynphy_wrf_prescribed_void_lmd_new/update_outputs_physiq_mod.F	(revision 2018)
@@ -71,6 +71,9 @@
             SWDOWNZ,TAU_DUST,QSURFDUST,&
             MTOT,ICETOT,TAU_ICE,&
-            HR_SW,HR_LW,HR_DYN,DT,DTRAD,DTVDF,DTAJS,&
-            RDUST,VMR_ICE,RICE)
+            HR_SW,HR_LW,HR_DYN,DT,DTRAD,&
+            RDUST,VMR_ICE,RICE,&
+            CLOUDFRAC,TOTCLOUDFRAC,&
+            RAIN,SNOW,REEVAP,SURFRAIN,ALBEQ,FLUXTOP_DN,FLUXABS_SW,FLUXTOP_LW,FLUXSURF_SW,&
+            FLUXSURF_LW,FLXGRD,LSCEZ,H2OICE_REFF,LATENT_HF)
 
    INTEGER, INTENT(IN) :: ims,ime,jms,jme,kms,kme
@@ -78,9 +81,11 @@
    REAL, DIMENSION( ims:ime, jms:jme ), INTENT(INOUT) :: &
      SWDOWNZ,TAU_DUST,QSURFDUST,&
-     MTOT,ICETOT,TAU_ICE
+     MTOT,ICETOT,TAU_ICE,&
+     TOTCLOUDFRAC,ALBEQ,FLUXTOP_DN,FLUXABS_SW,FLUXTOP_LW,FLUXSURF_SW,&
+     FLUXSURF_LW,FLXGRD,LATENT_HF,REEVAP,SURFRAIN
    REAL, DIMENSION( ims:ime, kms:kme, jms:jme ), INTENT(INOUT ) :: &
-     HR_SW,HR_LW,HR_DYN,RDUST,VMR_ICE,RICE,DT,DTRAD,DTVDF,DTAJS
-   INTEGER :: i,j,subs,k
-   REAL, DIMENSION(kms:kme) :: phr_sw,phr_lw,phr_dyn
+     HR_SW,HR_LW,RDUST,VMR_ICE,RICE,CLOUDFRAC,HR_DYN,DT,DTRAD,RAIN,SNOW,&
+     LSCEZ,H2OICE_REFF
+   INTEGER :: i,j,subs
 
   open(17,file='prescribed_sw.txt',form='formatted',status='old')
Index: trunk/MESOSCALE/LMD_MM_MARS/SRC/WRFV2/phys/dynphy_wrf_venus_lmd_new/update_outputs_physiq_mod.F
===================================================================
--- trunk/MESOSCALE/LMD_MM_MARS/SRC/WRFV2/phys/dynphy_wrf_venus_lmd_new/update_outputs_physiq_mod.F	(revision 2016)
+++ trunk/MESOSCALE/LMD_MM_MARS/SRC/WRFV2/phys/dynphy_wrf_venus_lmd_new/update_outputs_physiq_mod.F	(revision 2018)
@@ -160,7 +160,10 @@
             SWDOWNZ,TAU_DUST,QSURFDUST,&
             MTOT,ICETOT,TAU_ICE,&
-            HR_SW,HR_LW,HR_DYN,DT,DTRAD,DTVDF,DTAJS,&
-            RDUST,VMR_ICE,RICE)
-
+            HR_SW,HR_LW,HR_DYN,DT,DTRAD,&
+            RDUST,VMR_ICE,RICE,&
+            CLOUDFRAC,TOTCLOUDFRAC,&
+            RAIN,SNOW,REEVAP,SURFRAIN,ALBEQ,FLUXTOP_DN,FLUXABS_SW,FLUXTOP_LW,FLUXSURF_SW,&
+            FLUXSURF_LW,FLXGRD,LSCEZ,H2OICE_REFF,LATENT_HF)
+   
    USE comm_wrf !! to get fields to be written from physiq
 
@@ -169,8 +172,12 @@
    REAL, DIMENSION( ims:ime, jms:jme ), INTENT(INOUT) :: &
      SWDOWNZ,TAU_DUST,QSURFDUST,&
-     MTOT,ICETOT,TAU_ICE
+     MTOT,ICETOT,TAU_ICE,&
+     TOTCLOUDFRAC,ALBEQ,FLUXTOP_DN,FLUXABS_SW,FLUXTOP_LW,FLUXSURF_SW,&
+     FLUXSURF_LW,FLXGRD,LATENT_HF,REEVAP,SURFRAIN
    REAL, DIMENSION( ims:ime, kms:kme, jms:jme ), INTENT(INOUT ) :: &
-     HR_SW,HR_LW,HR_DYN,RDUST,VMR_ICE,RICE,DT,DTRAD,DTVDF,DTAJS
-   INTEGER :: i,j,subs
+     HR_SW,HR_LW,RDUST,VMR_ICE,RICE,CLOUDFRAC,HR_DYN,DT,DTRAD,RAIN,SNOW,&
+     LSCEZ,H2OICE_REFF
+   INTEGER :: i,j,subs
+
 
    DO j = jps,jpe
Index: trunk/MESOSCALE/LMD_MM_MARS/SRC/WRFV2/phys/module_lmd_driver.F.new
===================================================================
--- trunk/MESOSCALE/LMD_MM_MARS/SRC/WRFV2/phys/module_lmd_driver.F.new	(revision 2016)
+++ trunk/MESOSCALE/LMD_MM_MARS/SRC/WRFV2/phys/module_lmd_driver.F.new	(revision 2018)
@@ -40,5 +40,8 @@
         isfflx, diff_opt, km_opt, &
         HISTORY_INTERVAL, &
-        HR_SW,HR_LW,HR_DYN,DDT,DT_RAD,DT_VDF,DT_AJS,SWDOWNZ,&
+        HR_SW,HR_LW,HR_DYN,DDT,DT_RAD,DT_VDF,DT_AJS,&
+        CLOUDFRAC,TOTCLOUDFRAC, &
+        GRAIN,GSNOW,REEVAP,SURFRAIN,ALBEQ,FLUXTOP_DN,FLUXABS_SW,FLUXTOP_LW,FLUXSURF_SW,&
+        FLUXSURF_LW,FLXGRD,LSCEZ,H2OICE_REFF,LATENT_HF,SWDOWNZ,&
         TAU_DUST,RDUST,QSURFDUST,&
         MTOT,ICETOT,VMR_ICE,TAU_ICE,RICE,&
@@ -104,5 +107,6 @@
      MTOT,ICETOT,TAU_ICE,&
      HFMAX,ZMAX,&
-     USTM,HFX
+     USTM,HFX,TOTCLOUDFRAC,ALBEQ,FLUXTOP_DN,FLUXABS_SW,FLUXTOP_LW,FLUXSURF_SW,&
+     FLUXSURF_LW,FLXGRD,LATENT_HF,REEVAP,SURFRAIN
 ! 3D arrays 
 REAL, DIMENSION( ims:ime, kms:kme, jms:jme ), INTENT(IN ) :: &
@@ -110,5 +114,6 @@
 REAL, DIMENSION( ims:ime, kms:kme, jms:jme ), INTENT(OUT ) :: &
      RTHBLTEN,RUBLTEN,RVBLTEN, &
-     HR_SW,HR_LW,HR_DYN,DDT,DT_RAD,DT_VDF,DT_AJS,RDUST,VMR_ICE,RICE
+     HR_SW,HR_LW,HR_DYN,DDT,DT_RAD,DT_VDF,DT_AJS,RDUST,VMR_ICE,RICE,&
+     CLOUDFRAC,GRAIN,GSNOW,LSCEZ,H2OICE_REFF
 REAL, DIMENSION( ims:ime, kms:kme+1, jms:jme ), INTENT(INOUT ) :: &
      M_Q2
@@ -734,6 +739,10 @@
             SWDOWNZ,TAU_DUST,QSURFDUST,&
             MTOT,ICETOT,TAU_ICE,&
-            HR_SW,HR_LW,HR_DYN,DDT,DT_RAD,DT_VDF,DT_AJS,&
-            RDUST,VMR_ICE,RICE)
+            HR_SW,HR_LW,HR_DYN,DDT,DT_RAD,&
+            RDUST,VMR_ICE,RICE,&
+            CLOUDFRAC,TOTCLOUDFRAC,&
+            GRAIN,GSNOW,REEVAP,SURFRAIN,&
+            ALBEQ,FLUXTOP_DN,FLUXABS_SW,FLUXTOP_LW,FLUXSURF_SW,&
+            FLUXSURF_LW,FLXGRD,LSCEZ,H2OICE_REFF,LATENT_HF)
 !!!
 print *, '** ',planet_type,'** OUTPUT PHYSICS DONE'