Index: trunk/LMDZ.MARS/libf/aeronomars/chimiedata.h
===================================================================
--- trunk/LMDZ.MARS/libf/aeronomars/chimiedata.h	(revision 2007)
+++ trunk/LMDZ.MARS/libf/aeronomars/chimiedata.h	(revision 2024)
@@ -38,5 +38,5 @@
 !--------------------------------------------
 
-      integer, parameter :: nb_phot_max       = 18
+      integer, parameter :: nb_phot_max       = 22
       integer, parameter :: nb_reaction_3_max = 6
-      integer, parameter :: nb_reaction_4_max = 30
+      integer, parameter :: nb_reaction_4_max = 31
Index: trunk/LMDZ.MARS/libf/aeronomars/photochemistry.F90
===================================================================
--- trunk/LMDZ.MARS/libf/aeronomars/photochemistry.F90	(revision 2007)
+++ trunk/LMDZ.MARS/libf/aeronomars/photochemistry.F90	(revision 2024)
@@ -160,6 +160,6 @@
 hetero_ice  = .true.
 
-call reactionrates(nlayer, lswitch, dens, c(:,i_co2), c(:,i_o2), &
-                   press, temp, hetero_dust, hetero_ice,         &
+call reactionrates(nlayer, lswitch, dens, c(:,i_co2), c(:,i_o2),              &
+                   c(:,i_o), c(:,i_n2), press, temp, hetero_dust, hetero_ice, &
                    surfdust1d, surfice1d, v_phot, v_3, v_4)
 
@@ -386,8 +386,8 @@
 !======================================================================
 
- subroutine reactionrates(nlayer,                               &
-                          lswitch, dens, co2, o2, press, t,     &
-                          hetero_dust, hetero_ice,              &
-                          surfdust1d, surfice1d,                &
+ subroutine reactionrates(nlayer,                                  &
+                          lswitch, dens, co2, o2, o, n2, press, t, &
+                          hetero_dust, hetero_ice,                 &
+                          surfdust1d, surfice1d,                   &
                           v_phot, v_3, v_4)
  
@@ -423,4 +423,6 @@
 real (kind = 8), dimension(nlayer) :: co2    ! co2 number density (molecule.cm-3)
 real (kind = 8), dimension(nlayer) :: o2     ! o2 number density (molecule.cm-3)
+real (kind = 8), dimension(nlayer) :: o      ! o number density (molecule.cm-3)
+real (kind = 8), dimension(nlayer) :: n2     ! n2 number density (molecule.cm-3)
 logical :: hetero_dust, hetero_ice           ! switches for heterogeneous chemistry
 
@@ -443,13 +445,13 @@
 real, dimension(nlayer) :: deq
 real, dimension(nlayer) :: a001, a002, a003,                           &
-                             b001, b002, b003, b004, b005, b006, b007,   &
-                             b008, b009,                                 &
-                             c001, c002, c003, c004, c005, c006, c007,   &
-                             c008, c009, c010, c011, c012, c013, c014,   &
-                             c015, c016, c017, c018,                     &
-                             d001, d002, d003, d004, d005, d006, d007,   &
-                             d008, d009,                                 &
-                             e001, e002,                                 &
-                             h001, h002, h003, h004, h005
+                           b001, b002, b003, b004, b005, b006, b007,   &
+                           b008, b009,                                 &
+                           c001, c002, c003, c004, c005, c006, c007,   &
+                           c008, c009, c010, c011, c012, c013, c014,   &
+                           c015, c016, c017, c018,                     &
+                           d001, d002, d003, d004, d005, d006, d007,   &
+                           d008, d009, d010, d011, d012,               &
+                           e001, e002,                                 &
+                           h001, h002, h003, h004, h005
 
 !----------------------------------------------------------------------
@@ -457,5 +459,5 @@
 !----------------------------------------------------------------------
 
-      nb_phot       = 11       ! jmars.20140930 reduit de 13 a 11
+      nb_phot       = 13       ! jmars.20140930(13) - hno3 - hno4 + h2 + n2
       nb_reaction_3 = 0
       nb_reaction_4 = 0
@@ -851,4 +853,31 @@
       nb_reaction_4 = nb_reaction_4 + 1
       v_4(:,nb_reaction_4) = d009(:)
+
+!---  d010: n(2d) + o  -> n + o
+
+!     herron, j. phys. chem. ref. data, 1999
+
+      d010(:) = 3.3e-12*exp(-260./t(:))
+
+      nb_phot = nb_phot + 1
+      v_phot(:,nb_phot) = d010(:)*o(:)
+
+!---  d011: n(2d) + n2  -> n + n2
+
+!     herron, j. phys. chem. ref. data, 1999
+
+      d011(:) = 1.7e-14
+
+      nb_phot = nb_phot + 1
+      v_phot(:,nb_phot) = d011(:)*n2(:)
+
+!---  d012: n(2d) + co2  -> no + co
+
+!     herron, j. phys. chem. ref. data, 1999
+
+      d012(:) = 3.6e-13
+
+      nb_reaction_4 = nb_reaction_4 + 1
+      v_4(:,nb_reaction_4) = d012(:)
 
 !----------------------------------------------------------------------
@@ -1226,4 +1255,12 @@
 
 !===========================================================
+!      H2 + hv -> H + H
+!===========================================================
+
+nb_phot = nb_phot + 1
+
+indice_phot(nb_phot) = z3spec(1.0, i_h2, 1.0, i_h, 1.0, i_h) 
+
+!===========================================================
 !      NO + hv -> N + O
 !===========================================================
@@ -1242,4 +1279,12 @@
 
 !===========================================================
+!      N2 + hv -> N + N
+!===========================================================
+
+nb_phot = nb_phot + 1
+
+indice_phot(nb_phot) = z3spec(1.0, i_n2, 1.0, i_n2d, 1.0, i_n) 
+
+!===========================================================
 !      a001 : O + O2 + CO2 -> O3 + CO2
 !===========================================================
@@ -1528,4 +1573,28 @@
 
 indice_4(nb_reaction_4) = z4spec(1.0, i_n, 1.0, i_oh, 1.0, i_no, 1.0, i_h) 
+
+!===========================================================
+!      d010 : N(2D) + O -> N + O
+!===========================================================
+
+nb_phot = nb_phot + 1
+
+indice_phot(nb_phot) = z3spec(1.0, i_n2d, 1.0, i_n, 0.0, i_dummy) 
+
+!===========================================================
+!      d011 : N(2D) + N2 -> N + N2
+!===========================================================
+
+nb_phot = nb_phot + 1
+
+indice_phot(nb_phot) = z3spec(1.0, i_n2d, 1.0, i_n, 0.0, i_dummy) 
+
+!===========================================================
+!      d012 : N(2D) + CO2 -> NO + CO
+!===========================================================
+
+nb_reaction_4 = nb_reaction_4 + 1
+
+indice_4(nb_reaction_4) = z4spec(1.0, i_n2d, 1.0, i_co2, 1.0, i_no, 1.0, i_co) 
 
 !===========================================================
Index: trunk/LMDZ.MARS/libf/aeronomars/photolysis.F90
===================================================================
--- trunk/LMDZ.MARS/libf/aeronomars/photolysis.F90	(revision 2007)
+++ trunk/LMDZ.MARS/libf/aeronomars/photolysis.F90	(revision 2024)
@@ -43,9 +43,5 @@
       integer :: j_o2_o, j_o2_o1d, j_co2_o, j_co2_o1d, j_o3_o1d,        &
                  j_o3_o, j_h2o, j_hdo, j_h2o2, j_ho2, j_no, j_no2,      &
-                 j_hno3, j_hno4,                                        &
-                 j_ch4_ch3_h, j_ch4_1ch2_h2, j_ch4_3ch2_h_h,            &
-                 j_ch4_ch_h2_h, j_ch3o2h, j_ch2o_hco, j_ch2o_co,        &
-                 j_ch3oh, j_c2h6, j_hcl, j_hocl, j_clo, j_so2, j_so,    &
-                 j_h2s, j_so3
+                 j_hno3, j_hno4
 
       real :: col(nlayer)                 ! overhead air column   (molecule cm-2)
@@ -323,36 +319,4 @@
       j_hno4         =  13     ! hno4 + hv   -> no2 + ho2
 
-! jmars.20111014
-
-!     j_o2_o         =  1      ! o2 + hv     -> o + o
-!     j_o2_o1d       =  2      ! o2 + hv     -> o + o(1d)
-!     j_co2_o        =  3      ! co2 + hv    -> co + o
-!     j_co2_o1d      =  4      ! co2 + hv    -> co + o(1d)
-!     j_o3_o1d       =  5      ! o3 + hv     -> o2 + o(1d)
-!     j_o3_o         =  6      ! o3 + hv     -> o2 + o
-!     j_h2o          =  7      ! h2o + hv    -> h + oh
-!     j_hdo          =  8      ! hdo + hv    -> d + oh
-!     j_h2o2         =  9      ! h2o2 + hv   -> oh + oh
-!     j_ho2          =  10     ! ho2 + hv    -> oh + o
-!     j_no2          =  11     ! no2 + hv    -> no + o
-!     j_ch4_ch3_h    =  12     ! ch4 + hv    -> ch3 + h
-!     j_ch4_1ch2_h2  =  13     ! ch4 + hv    -> 1ch2 + h2
-!     j_ch4_3ch2_h_h =  14     ! ch4 + hv    -> 3ch2 + h + h
-!     j_ch4_ch_h2_h  =  15     ! ch4 + hv    -> ch + h2 + h
-!     j_ch3o2h       =  16     ! ch3o2h + hv -> ch3o + oh
-!     j_ch2o_hco     =  17     ! ch2o + hv   -> h + hco
-!     j_ch2o_co      =  18     ! ch2o + hv   -> h2 + co
-!     j_ch3oh        =  19     ! ch3oh + hv  -> ch3o + h
-!     j_c2h6         =  20     ! c2h6 + hv   -> products
-!     j_hcl          =  21     ! hcl + hv    -> h + cl
-!     j_hocl         =  22     ! hocl + hv   -> oh + cl
-!     j_clo          =  23     ! clo + hv    -> o + cl
-!     j_so2          =  24     ! so2 + hv    -> so + o
-!     j_so           =  25     ! so + hv     -> s + o
-!     j_h2s          =  26     ! h2s + hv    -> hs + s
-!     j_so3          =  27     ! so2 + hv    -> so2 + o
-!     j_hno3         =  28     ! hno3 + hv   -> oh + no2
-!     j_hno4         =  29     ! hno4 + hv   -> ho2 + no2
-
 ! fill v_phot array
 
@@ -369,6 +333,8 @@
          v_phot(l, 8) = j(l,j_h2o2)
          v_phot(l, 9) = j(l,j_ho2)
-         v_phot(l,10) = j(l,j_no)
-         v_phot(l,11) = j(l,j_no2)
+         v_phot(l,10) = 0.         ! h2 
+         v_phot(l,11) = j(l,j_no)
+         v_phot(l,12) = j(l,j_no2)
+         v_phot(l,13) = 0.         ! n2
       end do
 