Index: /trunk/LMDZ.MARS/libf/aeronomars/calchim.F90
===================================================================
--- /trunk/LMDZ.MARS/libf/aeronomars/calchim.F90	(revision 2030)
+++ /trunk/LMDZ.MARS/libf/aeronomars/calchim.F90	(revision 2031)
@@ -2,5 +2,5 @@
                          ptimestep,pplay,pplev,pt,pdt,dist_sol,mu0,         &
                          zzlev,zzlay,zday,pq,pdq,dqchim,dqschim,dqcloud,    &
-                         dqscloud,tauref,co2ice,                            &
+                         dqscloud,tau,co2ice,                               &
                          pu,pdu,pv,pdv,surfdust,surfice)
 
@@ -43,5 +43,5 @@
 !  Input:
 !
-!    ptimestep                  timestep (s)
+!    ptimestep              timestep (s)
 !    pplay(ngrid,nlayer)    Pressure at the middle of the layers (Pa)
 !    pplev(ngrid,nlayer+1)  Intermediate pressure levels (Pa)
@@ -52,10 +52,10 @@
 !    pv(ngrid,nlayer)       v component of the wind (ms-1)
 !    pdv(ngrid,nlayer)      v component tendency (K)
-!    dist_sol                   distance of the sun (AU)
-!    mu0(ngrid)               cos of solar zenith angle (=1 when sun at zenith)
-!    pq(ngrid,nlayer,nq)  Advected fields, ie chemical species here
-!    pdq(ngrid,nlayer,nq) Previous tendencies on pq
-!    tauref(ngrid)            Optical depth at 7 hPa
-!    co2ice(ngrid)            co2 ice surface layer (kg.m-2)
+!    dist_sol               distance of the sun (AU)
+!    mu0(ngrid)             cos of solar zenith angle (=1 when sun at zenith)
+!    pq(ngrid,nlayer,nq)    advected fields, ie chemical species here
+!    pdq(ngrid,nlayer,nq)   previous tendencies on pq
+!    tau(ngrid)             dust optical depth
+!    co2ice(ngrid)          co2 ice surface layer (kg.m-2)
 !    surfdust(ngrid,nlayer) dust surface area (m2/m3)
 !    surfice(ngrid,nlayer)  ice surface area (m2/m3)
@@ -63,6 +63,6 @@
 !  Output:
 !
-!    dqchim(ngrid,nlayer,nq) ! tendencies on pq due to chemistry
-!    dqschim(ngrid,nq)         ! tendencies on qsurf 
+!    dqchim(ngrid,nlayer,nq) tendencies on pq due to chemistry
+!    dqschim(ngrid,nq)       tendencies on qsurf 
 !
 !=======================================================================
@@ -91,8 +91,8 @@
       real :: pdq(ngrid,nlayer,nq)   ! previous tendencies
       real :: zday                   ! date (time since Ls=0, in martian days)
-      real :: tauref(ngrid)          ! Reference column optical depth
+      real :: tau(ngrid)             ! dust optical depth
       real :: co2ice(ngrid)          ! co2 ice surface layer (kg.m-2)
       real :: surfdust(ngrid,nlayer) ! dust surface area (m2/m3)
-      real :: surfice(ngrid,nlayer)  !  ice surface area (m2/m3)
+      real :: surfice(ngrid,nlayer)  ! ice surface area (m2/m3)
 
 !     output:
@@ -655,5 +655,5 @@
 
          szacol = acos(mu0(ig))*180./pi
-         taucol = tauref(ig)*(700./610.)  ! provisoire en attente de nouveau jmars
+         taucol = tau(ig)
 
 !=======================================================================
Index: /trunk/LMDZ.MARS/libf/aeronomars/chimiedata.h
===================================================================
--- /trunk/LMDZ.MARS/libf/aeronomars/chimiedata.h	(revision 2030)
+++ /trunk/LMDZ.MARS/libf/aeronomars/chimiedata.h	(revision 2031)
@@ -16,6 +16,4 @@
 !--------------------------------------------
 
-      real, parameter :: kb = 1.3806e-23
-
       common/chimiedata/jphot,colairtab,table_ozo
 
Index: /trunk/LMDZ.MARS/libf/aeronomars/photochemistry.F90
===================================================================
--- /trunk/LMDZ.MARS/libf/aeronomars/photochemistry.F90	(revision 2030)
+++ /trunk/LMDZ.MARS/libf/aeronomars/photochemistry.F90	(revision 2031)
@@ -43,5 +43,5 @@
 real :: surfdust1d(nlayer)    ! dust surface area (cm2/cm3)
 real :: surfice1d(nlayer)     ! ice surface area (cm2/cm3)
-real :: tau                   ! reference dust optical depth
+real :: tau                   ! dust optical depth
 
 !===================================================================
@@ -147,5 +147,4 @@
 if (jonline) then
    if (sza <= 113.) then ! day at 300 km
-      tau = tau*press(1)/7.  ! temporary
       call photolysis_online(nlayer, alt, press, temp, zmmean,          &
                              i_co2, i_co, i_o, i_o1d, i_o2, i_o3, i_h,  &
@@ -157,4 +156,5 @@
    end if
 else
+   tau = tau*7./press(1) ! dust in the lookup table is at 7 hpa
    call photolysis(nlayer, lswitch, press, temp, sza, tau, zmmean, dist_sol, & 
                    rm(:,i_co2), rm(:,i_o3), v_phot)
Index: /trunk/LMDZ.MARS/libf/phymars/physiq_mod.F
===================================================================
--- /trunk/LMDZ.MARS/libf/phymars/physiq_mod.F	(revision 2030)
+++ /trunk/LMDZ.MARS/libf/phymars/physiq_mod.F	(revision 2031)
@@ -1590,5 +1590,5 @@
      &                   ptimestep,zplay,zplev,pt,pdt,dist_sol,mu0,
      $                   zzlev,zzlay,zday,pq,pdq,zdqchim,zdqschim,
-     $                   zdqcloud,zdqscloud,tauref,co2ice,
+     $                   zdqcloud,zdqscloud,tau(:,1),co2ice,
      $                   pu,pdu,pv,pdv,surfdust,surfice)
 