Index: /trunk/MESOSCALE/LMD_MM_MARS/SRC/WRFV2/phys/dynphy_wrf_generic_lmd_new/callphysiq_mod.F
===================================================================
--- /trunk/MESOSCALE/LMD_MM_MARS/SRC/WRFV2/phys/dynphy_wrf_generic_lmd_new/callphysiq_mod.F	(revision 2067)
+++ /trunk/MESOSCALE/LMD_MM_MARS/SRC/WRFV2/phys/dynphy_wrf_generic_lmd_new/callphysiq_mod.F	(revision 2068)
@@ -8,7 +8,7 @@
 CONTAINS
 
-SUBROUTINE call_physiq(planet_type,klon,llm,nqtot,tname,                  &
+SUBROUTINE call_physiq(planet_type,klon,llm,nqtot,                  &
                        debut_split,lafin_split)
-
+ 
   USE variables_mod
   USE physiq_mod, ONLY: physiq
@@ -24,6 +24,4 @@
   LOGICAL,INTENT(IN) :: debut_split ! .true. if very first call to physics
   LOGICAL,INTENT(IN) :: lafin_split ! .true. if last call to physics
-  REAL*8,INTENT(IN) :: JD_cur ! Julian day
-  REAL*8,INTENT(IN) :: JH_cur_split ! Julian hour (fraction of day)
 
   ! Local variables
Index: /trunk/MESOSCALE/LMD_MM_MARS/SRC/WRFV2/phys/dynphy_wrf_generic_lmd_new/iniphysiq_mod.F
===================================================================
--- /trunk/MESOSCALE/LMD_MM_MARS/SRC/WRFV2/phys/dynphy_wrf_generic_lmd_new/iniphysiq_mod.F	(revision 2067)
+++ /trunk/MESOSCALE/LMD_MM_MARS/SRC/WRFV2/phys/dynphy_wrf_generic_lmd_new/iniphysiq_mod.F	(revision 2068)
@@ -3,6 +3,6 @@
 CONTAINS
 
-subroutine iniphysiq(ngrid,nlayer,nq,phour_ini,piphysiq,&
-                     punjours, pdayref,ptimestep, &
+subroutine iniphysiq(ngrid,nlayer,nq,piphysiq,&
+                     punjours, pdayref, &
                      prad,pg,pr,pcpp,iflag_phys)
 
@@ -43,5 +43,4 @@
 REAL,intent(in) :: punjours
 !DOUBLE PRECISION,intent(in) :: ptimestep
-REAL*8,intent(in) :: phour_ini
 
 !real,intent(in) :: prad ! radius of the planet (m)
@@ -51,5 +50,4 @@
 !real,intent(in) :: punjours ! length (in s) of a standard day [daysec]
 integer,intent(in) :: pdayref ! reference day of for the simulation [day_ini]
-real*8,intent(in) :: ptimestep !physics time step (s) [dtphys]
 integer,intent(in) :: iflag_phys ! type of physics to be called
 
@@ -67,4 +65,5 @@
 real*8 :: lat(ngrid),long(ngrid),cellarea(ngrid)
 REAL*8 :: pprad,ppg,ppr,ppcpp,ppunjours
+REAL*8 :: dummy 
   ! the common part for all planetary physics
   !------------------------------------------
@@ -92,5 +91,5 @@
 !endif
 
-
+dummy=1.
 lat(:)=0.
 long(:)=0.
@@ -103,5 +102,5 @@
 ppr=pr
 ppcpp=pcpp
-call inifis(ngrid,nlayer,nq,pdayref,ppunjours,nday,ptimestep, &
+call inifis(ngrid,nlayer,nq,pdayref,ppunjours,nday,dummy, &
             lat,long,cellarea,pprad,ppg,ppr,ppcpp)
 
Index: /trunk/MESOSCALE/LMD_MM_MARS/SRC/WRFV2/phys/dynphy_wrf_generic_lmd_new/update_inputs_physiq_mod.F
===================================================================
--- /trunk/MESOSCALE/LMD_MM_MARS/SRC/WRFV2/phys/dynphy_wrf_generic_lmd_new/update_inputs_physiq_mod.F	(revision 2067)
+++ /trunk/MESOSCALE/LMD_MM_MARS/SRC/WRFV2/phys/dynphy_wrf_generic_lmd_new/update_inputs_physiq_mod.F	(revision 2068)
@@ -24,5 +24,4 @@
   INTEGER, INTENT(IN) :: JULDAY, JULYR
   REAL, INTENT(IN) :: GMT,elaps,lon_input,ls_input,lct_input
-  REAL*8,INTENT(OUT) :: pday,ptime
   REAL,INTENT(OUT) :: MY
   REAL :: sec,nsec
@@ -70,5 +69,5 @@
 !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
 !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
-SUBROUTINE update_inputs_physiq_tracers(nq,MARS_MODE,tname)
+SUBROUTINE update_inputs_physiq_tracers(nq,MARS_MODE)
 
   use tracer_h, only: noms,nqtot
@@ -77,5 +76,5 @@
   INTEGER, INTENT(IN) :: nq,MARS_MODE
   INTEGER :: i,k
-  CHARACTER(len=20), INTENT(INOUT) :: tname(nq) ! tracer names
+!  CHARACTER(len=20), INTENT(INOUT) :: tname(nq) ! tracer names
   logical :: end_of_file
 
@@ -88,13 +87,13 @@
   nqtot=nq
   if (MARS_MODE .eq. 1) THEN
-    tname(1)="h2o_vap"
-    tname(2)="h2o_ice"
+    noms(1)="h2o_vap"
+    noms(2)="h2o_ice"
   else if (MARS_MODE .eq. 22)  then 
-    tname(1)="co2_vap"
-    tname(2)="co2_ice"
+    noms(1)="co2_vap"
+    noms(2)="co2_ice"
   else
-    tname(:)="zolbxs"
+    noms(:)="zolbxs"
   endif
-  noms(:)=tname(:)
+  !noms(:)=tname(:)
   print*,'noms',noms
   !!---------------------!!